import hou

def testCyl():
	#Creem un contenidor de geometria (un geo)
	#i ens carreguem el node File que el Houdini acostuma a crear.
	geoContainer = hou.node('/obj').createNode('geo')
	for n in geoContainer.children():
		n.destroy()
	
	#creem un tub, pero amb 8 cares
	base = geoContainer.createNode('tube')
	base.parm('type').set('poly')
	base.parm('cap').set(False)	#.set(True)
	base.parm('rad1').set("1")
	base.parm('rad2').set("1")
	base.parm('height').set("6")
	base.parm('rows').set("6")
	base.parm('cols').set("8")
	
	#ara, estirem les cares del tub amb un polyextrude
	p1 = geoContainer.createNode('polyextrude')
	p1.parm('ltx').set(0)
	p1.parm('lty').set(0)
	p1.parm('ltz').set(1)
	p1.parm('lsy').set(0.2)
	#p1.parm('newg').set(True)
	#Els conectem un a l'altre!!
	p1.setFirstInput(base)
	
	#Quan Houdini crea els nodes des de Python, els posa superposats i no es pot veure res...
	#LLavors, els movem a una posicio bona!
	for n in geoContainer.children():
		n.moveToGoodPosition()
	#i fem visible el que s'ha de veure!
	p1.setDisplayFlag(True)
	
#Funcio d'utilitat per veure els parametres que te un node GEO
def api(node):
	g = hou.node('/obj').createNode('geo')
	n = g.createNode(node)
	for x in n.parms():
		print x
		print n.parm(x.name()).parmTemplate()
		print "\n"
	g.destroy()
	
#Funcio d'utilitat per veure els parametres que te un node VEX
def api2(node):
	g = hou.node('/vex').createNode('surface')
	n = g.createNode(node)
	for x in n.parms():
		print x
		print n.parm(x.name()).parmTemplate()
		print "\n"
	g.destroy()
	
#Funcio d'utilitat per gravar a disc el codi que genera Houdini per a un node...
def dumpCode(base):
	filename = 'C:\dumped.py'
	FILE = open(filename,'w')
	text = base.asCode(brief=True, recurse=True,
			save_channels_only=False, save_creation_commands=True,
			save_keys_in_frames=False, save_outgoing_wires=False,
			save_parm_values_only=False, save_spare_parms=True,
			function_name='createNode')
	FILE.writelines(text)
	FILE.close()
	
def main():
	testCyl()