# ==================================================
# Node getters
# ==================================================
class nodeGetter:
	def __init__(self, parent):
		self.container = parent
		self.foundNodes = []
		
class getRootNodes(nodeGetter):
	def __init__(self, parent):
		nodeGetter.__init__(self, parent)
	def get(self):
		for m in self.container.children():
			if m.inputs() == () and m.outputs() != ():
				if m not in self.foundNodes:
					self.foundNodes.append(m)
		return self.foundNodes
	
class getLeafNodes(nodeGetter):
	def __init__(self, parent):
		nodeGetter.__init__(self, parent)
	def get(self):
		for m in self.container.children():
			if m.outputs() == () and m.inputs() != ():
				if m not in self.foundNodes:
					self.foundNodes.append(m)
		return self.foundNodes
	
class getIndependentNodes(nodeGetter):
	def __init__(self, parent):
		nodeGetter.__init__(self, parent)
	def get(self):
		for m in self.container.children():
			if m.inputs() == () and m.outputs() == ():
				if m not in self.foundNodes:
					self.foundNodes.append(m)
		return self.foundNodes

def test():
	import hou
	container = hou.node('/obj/example')
	print "getting leaves"
	print nodeGetters.getLeafNodes(container).get()
