def igetPath(node):
#It returns all the paths from node to root as [[path1][path2]...[pathN]]
	import types
	#Getting all the inputs from the parameter node
	inputs = node.inputs()
	multipleParents = []
	temp = []
	ret =  []
	if len(inputs)>0:
	#It has inputs so it is not the root
		if len(inputs)<2:
			#Only has one parent 
			ret = igetPath(inputs[0])
			#But we don't know if the result is a single list or multiple list
			if type(ret[0]) == types.ListType:
				#If its multiple, we must append to every list, 
				#the path from the leaf to the actual node
				for item in ret:
					temp.append([node]+item)
			else:
				temp.append([node]+ret)
		else:
			#There are multiple parents, so its necessary 
			#to add a list for every parent that will generate a new full path
			for item in inputs:
				multipleParents.append(igetPath(item))
			#Here we have all the paths resulting from the parameter node to the root
			for item in range(len(multipleParents)):
				#If we recive multiple paths, all must have the path 
				#from the leaf node to the actual node appended on the left.
				if type(multipleParents[item][0]) == types.ListType:
					for sublist in range(len(multipleParents[item])):
						temp.append([node]+multipleParents[item][sublist])
				else:
					temp.append([node]+multipleParents[item])
	else:
		temp.append([node])
	return temp
	
def getCommonAncestor(leafList):
#returns closest common ancestor list 
#(strictly talking, is possible to find more than one common Ancestor)
#It is assumed that there is only one root and it's common to all leafs
	paths = []
	indexing = []
	for item in leafList:
		#Get paths from item node.
		temp = igetPath(item)
		#Add the results on paths variable
		paths.append(temp)
		#Indexing [[Node1_PathList][Node2_PathList]...[NodeN_PathList]]
		#Wich every [NodeX_PathList] = [[1,2,...n]]
		indexing.append(range(len(temp)))

	result = []
	change = True
	while change:
		line = popNextLine(paths)
		actual = nextCandidates(line)
		if len(actual)<1:
			change = False
		else:
			result = actual
	return result

		
def popNextLine(paths):
#Return all the tops of the paths lists as stacks to check the commonness
	actual = []
	for i in paths:
		temp = []
		for j in i:
			if j:
				temp.append(j.pop())
		actual.append(temp)
	return actual
	
def nextCandidates(line):
#Line contains the result of popNextLine, all tops of stacks
#Returns a list with the candidates to a closer common ancestor
	sets = []
	for item in line:
		sets.append(set(item))
	if len(sets)>0:
		actual = sets[0]
		for item in sets:
			actual = actual & item
	else:
		actual = sets
	return actual
	
def getRoot(node):
	temp = node.inputs()
	if len(temp) > 0:
		return getRoot(temp[0])
	else:
		return node
		
def testTree():
	import hou
	n1 = hou.node('obj/geo1/N1');
	n2 = hou.node('obj/geo1/N2');
	hf1 = hou.node('obj/geo1/HF1');
	hf2 = hou.node('obj/geo1/HF2');
	p = hou.node('obj/geo1/P');
	r = getRoot(n1)
	print "Root = "+r.name()
	print "The common ancestors of nodes N1 and N2 are:"
	print getCommonAncestor([n1,n2])
	print "The common ancestors of nodes HF1 and HF2 are:"
	print getCommonAncestor([hf1,hf2])
	print "The common ancestors of nodes P are:"
	print getCommonAncestor([p])
	
def testRacc():
	import hou
	#Entre el node 1 i el 2 l'ancestre comu es Subdiv16
	#Entre el node 1 i el 3 l'ancestre comu es Subdiv4
	n1 = hou.node('obj/Raccolet/leftWing/plainWindow')
	n2 = hou.node('obj/Raccolet/leftWing/plainBalconyWindow')
	n3 = hou.node('obj/Raccolet/leftWing/door')
	#r1 = getCommonAncestor([n1,n2])
	#r2 = getCommonAncestor([n1,n3])
	