def igetPath(prim):
#Return recursively the list of parents from prim to root.
	import productTree
	result = [prim]
	p = productTree.parentPrim(prim)
	if p!=None:
		result.extend(igetPath(p))
	return result

def getCommonAncestor(primList):
#Searches in all primList lists, which is the closest common ancestor
#In worst case the common ancestor will be the root node.
	paths = []
	for item in primList:
		temp = igetPath(item)
		paths.append(temp)
	result = []
	change = True
	while change:
		line = popNextLine(paths)
		actual = nextCandidates(line)
		if actual:
			result = actual
		else:
			change = False
	return result

def popNextLine(paths):
#Return all the tops of the paths lists as stacks to check the commonness
	actual = []
	for i in paths:
		if i:
			actual.append(i.pop())
	return actual
	
def nextCandidates(line):
#Line contains the result of popNextLine, all tops of stacks
#Returns the next candidate to a closer common ancestor as a list
	result = set(line)
	if len(result)==1:
		return list(result)
	else:
		return []
	
def getSelectedPrims():
#This method get the list of all user selected primitives, if the user has 
#not selected any geometry, it puts Houdini in selection mode, and waits until
#the user select some primitives.
	import hou
	import toolutils
	viewer = toolutils.sceneViewer() 
	geo = viewer.selectGeometry()
	result = []
	print "selectedNodes: "+str(hou.selectedNodes())
	if hou.selectedNodes():
		g = hou.selectedNodes()[0].geometry()
		primlist = geo.mergedSelectionString().split(' ')
		print primlist
		#Some primitives may be found as a group like: 004-009 so this code list the rang
		#and add it to the result list
		for name in primlist:
			if len(name)>0:
				if name.find('-')==-1:
					result.append(g.prims()[int(name)])
				else:
					r = name.split('-')
					result+=[g.prims()[int(r[0])]]
	return result

def startCommonSelection(quickSelection=True):
#quickSelection is a boolean that let toggle between a fast selection (only takes 4 primitives in corners of the selection rectagle),
#or a full selection (takes all primitives under the selection rectagle created by user).
#This method makes all the pipeline of selecting, getting primitive list, searching the commonAncestor and return it.
#If none primitive is found, it returns an empty list
	import selectPrim
	import math
	MergePrims = getSelectedPrims()
	print "MergePrims = "+str(MergePrims)+"\n"
	#MergePrims are primitives respect the merge that allow to visualize all the scene
	#But we need to know the primitive number of the node that generate it.
	if MergePrims:
		BEPrims = []
		if(MergePrims):
			#Here we search the primitive number respect the node that generate it.
			for item in MergePrims:
				selector = selectPrim.TopDownPrimSelector(item)
				print "Selector = "+str(selector)+"\n"
				node = selector.getBuildingPrim(item)
				print "Node = "+str(node)+"\n"
				#Once we know it, we must save it
				if node:
					BEPrims.append(node)
			#Then we compare which is the common ancestor from the real primitive numbers.
			print "BEPrims = "+str(BEPrims)+"\n"
			return getCommonAncestor(BEPrims)
		else:
			return []
	else:
		return []
