import hou
import sEp
import treeVisualizer
#import ExceptionManager
import productTree
import copyPasteOps
import graphRewriting

#exceptionManager = ExceptionManager.ExceptionManager()

def init():
	import loadOTL
	loadOTL.loadLibrary("copy&paste")
	loadOTL.loadLibrary("bE")
	loadOTL.loadLibrary("attribs")
	
	obj = hou.node('obj')
	if not hou.node('/obj/Interface'):
		parent = obj.createNode('geo','Interface')
		parent.children()[0].destroy()
		gui = parent.createNode('GUI','GUI')
		hou.parm('/obj/Interface/GUI/paste').hide(True)
		hou.parm('/obj/Interface/GUI/copy').hide(True)
	else:
		gui = hou.node('/obj/Interface/GUI')
	for n in hou.selectedNodes(): 
		n.setSelected(False)	
	gui.setSelected(True)

#This one is called from the menu of the tag parm at the GUI node.
#(remember: drop-down menues have two options: explicit menu or code...)
def showTAGList(GUI):
	#  Actually, this is not completely right: we should use the 
	#productTree to get the inserts which operate on descendants
	#of the current prim...
	list = []
	act = hou.node(GUI.parm('actualNode').eval())
	list = getTAGList(act,list)
	print(act)
	for node in list:
		print(node.parm('filter').eval())
	return list
	
def getTAGList(act,list):
	if act == None:
		return list
	elif act.type().name() == 'Insert':
		list.append(act)
	elif act.type().name() == 'attrib2Group':
		list.append(act)
	else:
		for node in act.outputs():
			list = getTAGList(node,list)
	return list
		
		
#def add_Excepion(GUI):
#	exceptionManager.add_Exception(GUI)
	
def init_Visuaizer(GUI):
	treeVisualizer.init_Visualizer(GUI)

def next_Prim(GUI):
	treeVisualizer.next_Prim(GUI)

def prev_Prim(GUI):		
	treeVisualizer.prev_Prim(GUI)
	
def up_Prim(GUI):
	treeVisualizer.up_Prim(GUI)
	
def down_Prim(GUI):
	treeVisualizer.down_Prim(GUI)

def fromSelection(GUI):
	treeVisualizer.fromPrimSelection(GUI)

def toggleQuickSelection(GUI):
	copyPasteOps.toggleQSelect(GUI)
	
def loadCopyFile(GUI):
	copyPasteOps.load_CopyFile(GUI)
	
def setSavePath(GUI):
	copyPasteOps.setSavePath(GUI)
	
def select_Geometry(GUI):
	copyPasteOps.select_Geometry(GUI)
	
def copy_Selection(GUI):
	copyPasteOps.copy_Selection(GUI)
	
def paste_Selection(GUI):
	copyPasteOps.paste_Selection(GUI)

		
	